package com.sample;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.runtime.manager.impl.SimpleRegisterableItemsFactory;
import org.kie.api.runtime.manager.RuntimeEnvironmentBuilder;
import org.kie.api.io.ResourceType;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.manager.RuntimeManagerFactory;
import org.kie.api.runtime.process.ProcessInstance;
import org.kie.internal.io.ResourceFactory;
import org.kie.internal.runtime.manager.context.EmptyContext;

/**
 * This is a sample file to launch a process.
 */
public class ProcessMainNoPersistence {

	public static final void main(String[] args) throws Exception {
        
		//Uncomment this line to test "rewards-basic_msg.bpmn2" process
          RuntimeManager manager = getRuntimeManager("rewards-basic_msg.bpmn2");

		//Uncomment this line to test "sample_doublemessagesignal.bpmn2" process
//        RuntimeManager manager = getRuntimeManager("sample_doublemessagesignal.bpmn2");
        
		//Uncomment this line to test "sample_doublesignal.bpmn2" process
		//RuntimeManager manager = getRuntimeManager("sample_doublesignal.bpmn2");

		
        RuntimeEngine runtime = manager.getRuntimeEngine(EmptyContext.get());
        KieSession ksession = runtime.getKieSession();

        // start a new process instance
		Map<String,Object> processVariable = new HashMap<String,Object> ();
		processVariable.put("p_result", "JUST_STARTED");
		
		//Here using this id "com.sample.rewards-basic_msg" to test any of the "rewards-basic_msg.bpmn2" or "sample_doublesignal.bpmn2" or "sample_doublemessagesignal.bpmn2" processes
		ProcessInstance pi = ksession.startProcess("com.sample.rewards-basic_msg", processVariable);

		System.out.println("A process instance started : pid = " + pi.getId());
		
		//Uncomment the following couple of lines to test "rewards-basic_msg.bpmn2" process
		ksession.signalEvent("Message-TestMessage1","Test",pi.getId());
		ksession.signalEvent("Message-TestMessage2","Test",pi.getId());
        
		//Uncomment the following line to test "sample_doublemessagesignal.bpmn2" process	
//		ksession.signalEvent("Message-TestMessage","Test",pi.getId());
		
		
		//Uncomment the following line to test "sample_doublesignal.bpmn2" process	
		//ksession.signalEvent("Signal_1","Test",pi.getId());
		
	
        ksession.dispose();

        System.exit(0);
    }

    private static RuntimeManager getRuntimeManager(String process) {
    	
        SimpleRegisterableItemsFactory simpleRegItemFactory = new SimpleRegisterableItemsFactory();
        
        RuntimeEnvironmentBuilder runtimeEnvBuilder = RuntimeEnvironmentBuilder.Factory.get().newEmptyBuilder()
                                                         .persistence(false)
                                                         .addAsset(ResourceFactory.newClassPathResource(process), ResourceType.BPMN2)
                                                         .registerableItemsFactory(simpleRegItemFactory);

        org.kie.api.runtime.manager.RuntimeEnvironment environment = runtimeEnvBuilder.get();

        return RuntimeManagerFactory.Factory.get().newPerProcessInstanceRuntimeManager(environment);

    }
}
